/*
   unix Τ socket-stream 饤֥
   socket-stream.h
   */

#ifndef __UNIX_SOCKET_STREAM_H__
#define __UNIX_SOCKET_STREAM_H__


#define CONFIGURE_MAX_FD
#include "configure.h"
#undef CONFIGURE_MAX_FD
#include "misc.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>


enum SocketStreamRole { SOCKET_STREAM_SERVER, SOCKET_STREAM_CLIENT };

union sockaddr_u
{
  sockaddr sa;
  sockaddr_in in;
};


struct SockAddr
{
  sockaddr_u u;
  int len;
  inline SockAddr(void) { Init(); }
  inline void Init(void) { memset((char *)&u, 0, len=sizeof(u)); }
};


class SocketStream
{
  int fd_socket;         // å
  int now_fd;            // Select ǼȤä fd
  SockAddr server_addr;  // СΥɥ쥹
  SocketStreamRole role; // SOCKET_STREAM_CLIENT, SOCKET_STREAM_SERVER
  fd_set fds;            // fd  (ޥå)
  fd_set fds_socket;     // åȤ fd 
  int write_select;      // write Ǥ select 뤫
  
  int is_readable(int fd, int sec, int usec);
  int read(const int fd, char* buf, const int bufsize, int sec, int usec);
  
public:
  
  inline SocketStream(void)
  {
    fd_socket=now_fd==-1;
    FD_ZERO(&fds);
    FD_ZERO(&fds_socket);
    write_select=False;
  }
  ~SocketStream(void);
  int Init(const SocketStreamRole _role, const char *hostname, const US port, int _write_select=False, int sec=0, int usec=0);
  // -1:顼 0:
  int Write(const int fd, const char *buf, const int bufsize);
  // -1:顼 else:bufsize
  int Read(const int fd, char *buf, const int bufsize, int sec=1, int usec=0);
  // -1:顼 else:readsize
  int Puts(const int fd, const char *buf);
  // -1:顼 else:readsize
  int Gets(const int fd, char *buf, const int bufsize, int sec=1, int usec=0);
  // -1:顼 else:bufsize
  int Select(const int sec, const int usec=0);
  //  -MAX_FD-2*MAX_FD+1: 褿 write ϤǤʤ
  //                    -2: ॢ
  //                    -1: 顼
  //        0   MAX_FD-1: 褿
  //   MAX_FD 2*MAX_FD-1: 饤Ȥ³
  // 2*MAX_FD 3*MAX_FD-1: 饤Ȥ³λ
  
  int Close(const int fd);
  inline void SelectThis(const int fd) { FD_SET(fd, &fds); }
  inline void NotSelectThis(const int fd) { FD_CLR(fd, &fds); }
  inline int Write(const char *buf, const int bufsize) { return Write(now_fd, buf, bufsize); }
  inline int Read(char *buf, const int bufsize) { return Read(now_fd, buf, bufsize); }
  inline int Puts(const char *buf) { return Puts(now_fd, buf); }
  inline int Gets(char *buf, const int bufsize) { return Gets(now_fd, buf, bufsize); }
  inline SocketStreamRole Role(void) const { return role; }
  inline US GetServerPort(void) const { return ntohs(server_addr.u.in.sin_port); }
  inline int SocketFD(void) const { return fd_socket; }

  static char *GetServer(const char * const server_port_str, const char * const default_server);
  static US GetPort(const char * const server_port_str, const US default_port);
};

#endif
